﻿using System;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;

namespace USBWriteProtect
{
    static class DriveMapper
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>

        [STAThread]

        #region Run single instance application for Win 10 / 11

        static void Main()
        {
            bool createdNew;
            using (Mutex mutex = new Mutex(true, "USBWPRTC_SINGLE_INSTANCE", out createdNew))
            {
                if (!createdNew)
                {
                    // Send message to bring existing instance to front
                    int msg = NativeMethods.RegisterWindowMessage("USBWPRTC_SHOW_ME");

                    foreach (var proc in Process.GetProcessesByName("USBWPRTC"))
                    {
                        if (proc.Id != Process.GetCurrentProcess().Id && proc.MainWindowHandle != IntPtr.Zero)
                        {
                            NativeMethods.PostMessage(proc.MainWindowHandle, msg, IntPtr.Zero, IntPtr.Zero);
                            break;
                        }
                    }

                    return; // Don't launch another instance
                }

                Application.EnableVisualStyles();
                Application.SetCompatibleTextRenderingDefault(false);
                Application.Run(new Form1());
            }
        }

        internal static class NativeMethods
        {
            [DllImport("user32.dll")]
            public static extern int RegisterWindowMessage(string lpString);

            [DllImport("user32.dll", SetLastError = true)]
            public static extern bool PostMessage(IntPtr hWnd, int Msg, IntPtr wParam, IntPtr lParam);
        }

        #endregion

        #region For Win 10 only

        //static void Main()
        //{
        //    bool createdNew;

        //    using (Mutex mutex = new Mutex(true, "USBWPRTC_SINGLE_INSTANCE", out createdNew))
        //    {
        //        if (!createdNew)
        //        {
        //            BringRunningInstanceToFront();
        //            return;
        //        }

        //        Application.EnableVisualStyles();
        //        Application.SetCompatibleTextRenderingDefault(false);
        //        Application.Run(new Form1());
        //    }
        //}

        //[DllImport("user32.dll")]
        //private static extern bool ShowWindow(IntPtr hWnd, int nCmdShow);

        //[DllImport("user32.dll")]
        //private static extern bool SetForegroundWindow(IntPtr hWnd);

        //[DllImport("user32.dll")]
        //private static extern bool IsIconic(IntPtr hWnd);

        //private const int SW_RESTORE = 9;
        //private const int SW_SHOW = 5;

        //private static void BringRunningInstanceToFront()
        //{
        //    string currentProcessName = Process.GetCurrentProcess().ProcessName;
        //    int currentProcessId = Process.GetCurrentProcess().Id;

        //    foreach (Process proc in Process.GetProcessesByName(currentProcessName))
        //    {
        //        if (proc.Id != currentProcessId && proc.MainWindowHandle != IntPtr.Zero)
        //        {
        //            IntPtr hWnd = proc.MainWindowHandle;

        //            // Restore from minimized
        //            if (IsIconic(hWnd))
        //            {
        //                ShowWindow(hWnd, SW_RESTORE);
        //            }
        //            else
        //            {
        //                ShowWindow(hWnd, SW_SHOW);
        //            }

        //            SetForegroundWindow(hWnd);
        //            break;
        //        }
        //    }
        //}

        #endregion

    }
}
