﻿Imports System
Imports System.IO
Imports System.Linq
Imports System.Runtime.InteropServices
Imports System.Windows.Forms
Imports Microsoft.Win32.SafeHandles
Imports System.Management
Imports System.Drawing
Imports System.Diagnostics
Imports System.Security.Principal
Imports System.Drawing.Drawing2D
Imports System.Text
Imports USBWriteProtect
Imports USBHelper

Public Class Form1

#Region "Variables : ตัวแปร"

    ''// กำหนดค่า Control ทั่วไป
    Private footerLabel As Label '' Footer label
    Private adminLabel As Label '' ADMIN label (สำหรับแสดงสถานะของ App ว่ารันอยู่ในโหมด Administrator หรือไม่)
    Private iconPath As String = Path.Combine(Application.StartupPath, "resources", "shieldok.ico") '' app icon (สำหรับแสดงสถานะของ App ว่ารันอยู่ในโหมด Administrator หรือไม่)
    Private blnLock As Boolean = True '' ค่าเริ่มต้นสำหรับการเปิดใช้งาน ช่องสำหรับกรอก รหัสผ่านเพื่อใช้งานปุ่ม Lock USB / UnLock USB ทำงานเมื่อกดปุ่มบนแป้นพิมพ์ Ctrl + Alt + L

    ''// กำหนดค่า หมายเลข sector ของ USB Flash Drive เพื่อทำการ ล็อค / ปลดล็อค (ทำงานในระบบฮาร์ดแวร์ มีผลล็อคทั้งไดรว์ ไม่ใช่การล็อคพาร์ทิชัน)
    ''// ทำให้ไม่สามารถทำการ เขียน ปรับปรุง หรือ ลบ ข้อมูล ให้อ่านได้อย่างเดียว แม้กระทั่งการฟอร์แมต ก็ไม่สามารถทำได้
    Private Const DEFAULT_SECTOR_NUMBER As Integer = 2  ''// หมายเลข sector ที่ใช้ในการกำหนดค่าการล็อคไม่ให้ทำการ เขียน ปรับปรุง หรือ ลบ ข้อมูล ให้อ่านได้อย่างเดียว

    ''// เปิดใช้งาน ฟังก์ชันการดักจับการเสียบ/ถอด USB ทำงานอัตโนมัติ โดยใช้ WMI Class บรรทัดที่ 320
    Private insertWatcher As ManagementEventWatcher ''// ฟังก์ชันการดักจับการเสียบ USB ทำงานอัตโนมัติ โดยใช้ WMI Class บรรทัดที่ 339
    Private removeWatcher As ManagementEventWatcher ''// ฟังก์ชันการดักจับการถอด USB ทำงานอัตโนมัติ โดยใช้ WMI Class บรรทัดที่ 346

    Private defaultAdminPass As String = "Admin1234" ''// รหัสผ่าน สำหรับเปิดใช้งานปุ่ม Lock USB / UnLock USB

#End Region

#Region "Constructure Settings : กำหนดค่าเริ่มต้น เมื่อเปิด App"

    Sub New()
        ' This call is required by the designer.
        InitializeComponent()

        '' การตั้งค่าให้ App รันได้แค่โปรเซสเดียว เพื่อป้องกันการเปิดฟอร์มเดียวหลาย ๆ หน้า
        'Run single instance application : setting on My Project -> Application tab -> Check for Make single instance application

        ' Add event for action buttons : กำหนดค่าการคลิกปุ่ม Read data , Lock USB และ UnLock USB (การทำงาน บรรทัด 362)
        AddHandler readButton.Click, Sub(s, evt)
                                         ReadSector(s, evt, DEFAULT_SECTOR_NUMBER)
                                     End Sub

        AddHandler lockButton.Click, Sub(s, evt)
                                         LockUSB(s, evt, DEFAULT_SECTOR_NUMBER)
                                     End Sub

        AddHandler unLockButton.Click, Sub(s, evt)
                                           UnLockUSB(s, evt, DEFAULT_SECTOR_NUMBER)
                                       End Sub

        'Add Admin Icon : ถ้าตรวจเจอ icon ให้แส้ง icon , ถ้าไม่เจอ icon ให้แสดงข้อความ "ADMIN" แทน icon (บรรทัด 138)
        If File.Exists(iconPath) Then
            ' Use a memory stream to avoid disposing the icon prematurely
            Using icon As New Icon(iconPath)
                topRightIcon.Image = icon.ToBitmap() ' Convert .ico to .bmp for PictureBox
            End Using

            '' Position at top-right corner
            'topRightIcon.Location = New Point(Me.ClientSize.Width - topRightIcon.Width - 5, 5)
            'topRightIcon.Anchor = AnchorStyles.Top Or AnchorStyles.Right

            ' Optional: click behavior
            topRightIcon.Cursor = Cursors.Default
            ' AddHandler topRightIcon.Click, Sub(s, e) MessageBox.Show("Shield icon clicked!")

            topRightIcon.Visible = False
        End If

        'Add USB drives to combo box : วนลูปหาอุปกรณ์ที่เป็น USB Storage (DriveType.Removable) แล้วใส่ลงไปใน ComboBox
        Try
            driveComboBox.DropDownStyle = ComboBoxStyle.DropDownList
            For Each drive As DriveInfo In DriveInfo.GetDrives()
                If drive.IsReady AndAlso drive.DriveType = DriveType.Removable Then
                    driveComboBox.Items.Add(drive.Name.TrimEnd("\"c) & " " & drive.VolumeLabel.ToString())
                End If
            Next

            If driveComboBox.Items.Count > 0 Then
                driveComboBox.SelectedIndex = 0 ' Select first drive by default
            End If
        Catch ex As Exception
            MessageBox.Show("Error: " & ex.Message, "Error !", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

            ' Prevent any control from being focused
            Me.SetNonActiveControl()
        Finally
            If driveComboBox.Items.Count > 0 Then
                driveComboBox.Enabled = True
                driveComboBox.SelectedIndex = 0
            Else
                driveComboBox.Enabled = False
            End If
        End Try

        'Set Password caption : กำหนดค่าแสดงข้อความในช่องรหัสผ่าน
        pswTextBox.Text = "Welcome to " + Me.Text
        pswTextBox.TextAlign = HorizontalAlignment.Center
        pswTextBox.MaxLength = 64
        pswTextBox.Enabled = False

        'USB Watchers : เริ่มใช้งานฟังก์ชันการดักจับการเสียบ/ถอด USB ทำงานอัตโนมัติ โดยใช้ WMI Class
        StartUSBWatchers()

    End Sub

#End Region

#Region "Form and Controls Events : เหตุการณ์ที่เกิดกับฟอร์ม และคอนโทรลต่าง ๆ"

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If Not IsAdministrator() Then
            ''// เช็คว่า App รันในโหมด Administrator หรือไม่ / ถ้าไม่ใช่ ให้รีสตาร์ท App ในโหมด Administrator
            Try
                Dim proc As ProcessStartInfo = New ProcessStartInfo With {
                    .UseShellExecute = True,
                    .WorkingDirectory = Environment.CurrentDirectory,
                    .FileName = Application.ExecutablePath,
                    .Verb = "runas"
                }
                Process.Start(proc)
            Catch
                MessageBox.Show("Administrator privileges are required to run this application.", "Permission Required", MessageBoxButtons.OK, MessageBoxIcon.[Error])
            End Try

            Application.Exit()
            Return
        End If

        If File.Exists(iconPath) Then ''// ถ้าตรวจเจอ icon ให้แส้ง icon , ถ้าไม่เจอ icon ให้แสดงข้อความ "ADMIN" แทน icon
            topRightIcon.Visible = True
        Else
            adminLabel.Visible = True
        End If

        readButton.Enabled = (driveComboBox IsNot Nothing AndAlso driveComboBox.Items.Count > 0)
    End Sub

    Private Sub Form1_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        If Me.WindowState = FormWindowState.Minimized Then
            Me.WindowState = FormWindowState.Normal
        End If

        Me.BringToFront()
        Me.Activate()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        If insertWatcher IsNot Nothing Then '' ปิดการใช้งานฟังก์ชันการดักจับการเสียบ USB
            insertWatcher.Stop()
            insertWatcher.Dispose()
            insertWatcher = Nothing
        End If

        If removeWatcher IsNot Nothing Then '' ปิดการใช้งานฟังก์ชันการดักจับการถอด USB
            removeWatcher.Stop()
            removeWatcher.Dispose()
            removeWatcher = Nothing
        End If
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        If e.Control AndAlso e.Alt AndAlso e.KeyCode = Keys.L Then '' เช็คว่ามีการกดปุ่มบนแป้นพิมพ์ Ctrl + Alt + L หรือไม่
            ' Enable input and mask
            pswTextBox.Enabled = True
            pswTextBox.PasswordChar = "•"c
            pswTextBox.Clear()
            pswTextBox.Focus()

            lockButton.Enabled = False
            unLockButton.Enabled = False
            readButton.Enabled = True

            If Me.blnLock = True Then '' เช็คสถานะการล็อค
                Dim driveLetter As String = TryCast(driveComboBox.SelectedItem, String)
                If String.IsNullOrEmpty(driveLetter) Then ''เช็คว่ามีไดรว์อยู่ในรายการของ ComboBox หรือไม่
                    MessageBox.Show("Please select a USB device !", "Warning !", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    Me.SetNonActiveControl()
                    Return
                End If

                If Not driveLetter.EndsWith("\") Then
                    driveLetter &= "\"
                End If

                Dim driveToCheck As New DriveInfo(driveLetter)
                If Not driveToCheck.IsReady Then '' เช็คว่าไดรว์อยู่ในสถานะพร้อมใช้งานหรือไม่
                    MessageBox.Show("The selected drive is not ready !", "Error !", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    Me.SetNonActiveControl()
                    Return
                End If

                Me.pswTextBox.Enabled = True '' เปิดใช้งานช่องกรอกรหัสผ่าน
                Me.pswTextBox.Focus()
            Else '' ปลดล็อค เมื่อกดปุ่มบนแป้นพิมพ์ Ctrl + Alt + L อีกครั้ง สลับกันไปกับการล็อค
                pswTextBox.Clear()
                pswTextBox.PasswordChar = ChrW(0)
                pswTextBox.Text = "Welcome to " & Me.Text
                pswTextBox.Enabled = False '' ปิดใช้งานช่องกรอกรหัสผ่าน
                pswTextBox.Focus()
            End If

            Me.blnLock = Not Me.blnLock
        End If

        If e.KeyCode = Keys.F5 Then '' ยกเลิกการโฟกัสที่ Control ใดๆ (บรรทัด 318)
            Me.SetNonActiveControl()
        End If
    End Sub

    Private Sub pswTextBox_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs) Handles pswTextBox.KeyDown
        If e.KeyCode = Keys.Enter Then
            ' e.SuppressKeyPress = True ' Optional: prevent beep sound

            If driveComboBox.SelectedItem Is Nothing Then
                ShowErrorAndReset("Please select a USB device !")
                Return
            End If

            Dim selectedItem As String = driveComboBox.SelectedItem.ToString()
            Dim driveLetter As String = selectedItem.Split(" "c)(0)
            If Not driveLetter.EndsWith("\") Then driveLetter &= "\"

            Dim driveToCheck As DriveInfo
            Try
                driveToCheck = New DriveInfo(driveLetter)
            Catch
                ShowErrorAndReset("Invalid drive selected !")
                Return
            End Try

            If Not driveToCheck.IsReady Then
                ShowErrorAndReset("The selected drive is not ready !")
                Return
            End If

            If driveToCheck.DriveType <> DriveType.Removable Then
                ShowErrorAndReset("The selected drive is not a removable USB device !")
                Return
            End If
            ''// เช็ครหัสผ่านตรงกับที่กำหนดไว้หรือไม่ : defaultAdminPass บรรทัด 34
            Dim password As String = pswTextBox.Text.Trim()
            If String.IsNullOrEmpty(password) OrElse password <> defaultAdminPass Then
                lockButton.Enabled = False
                unLockButton.Enabled = False
                readButton.Enabled = True

                ShowErrorAndReset("Password is incorrect !")
                Return
            End If

            ' ✅ Success : เปิดใช้งานปุ่ม ถ้ารหัสถูกต้อง
            lockButton.Enabled = True
            unLockButton.Enabled = True
            readButton.Enabled = True

            pswTextBox.Clear()
            pswTextBox.PasswordChar = ChrW(0) ' Unmask
            pswTextBox.Text = "You can Lock/UnLock USB device."
            pswTextBox.Enabled = False
            pswTextBox.Focus()
        End If
    End Sub

    Private Sub RefreshDriveComboBox() '' เกิดขึ้นเมื่อมีการ เสีบ / ถอด USB เพื่อสแกนหาไดรว์ทั้งหมด แล้วเพิ่มลงใน ComboBox อีกครั้ง (ทำงานอัตโนมัติ ร่วมกับ USB Watchers Events บรรทัด 325)
        If InvokeRequired Then
            BeginInvoke(New MethodInvoker(AddressOf RefreshDriveComboBox))
            Return
        End If

        driveComboBox.Items.Clear()

        Try

            For Each drive In DriveInfo.GetDrives()

                If drive.IsReady AndAlso drive.DriveType = DriveType.Removable Then
                    driveComboBox.Items.Add(drive.Name.TrimEnd("\"c) & " " + drive.VolumeLabel.ToString())
                End If
            Next

            If driveComboBox.Items.Count > 0 Then driveComboBox.SelectedIndex = 0
        Catch ex As Exception
            MessageBox.Show("Error: " & ex.Message, "Error !", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Me.SetNonActiveControl()
        Finally

            If driveComboBox.Items.Count > 0 Then
                driveComboBox.Enabled = True
                driveComboBox.SelectedIndex = 0
            Else
                driveComboBox.Enabled = False
            End If
        End Try
    End Sub

    Private Sub ShowErrorAndReset(ByVal message As String) '' สำหรับแสดงข้อความในรูปแบบ MessageBox
        MessageBox.Show(message, "Warning !", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        pswTextBox.Enabled = True
        pswTextBox.Clear()
        Me.BeginInvoke(New Action(Function() pswTextBox.Focus()))
    End Sub

    Private Function IsAdministrator() As Boolean '' สำหรับเช็คว่า App รันอยู่ในโหมด Administrator หรือไม่ แล้วคืนค่าเป็น True / False
        Dim identity As WindowsIdentity = WindowsIdentity.GetCurrent()
        Dim principal As WindowsPrincipal = New WindowsPrincipal(identity)
        Return principal.IsInRole(WindowsBuiltInRole.Administrator)
    End Function

    Private Sub SetNonActiveControl()
        ' Prevent any control from being focused : ยกเลิกการโฟกัส Control ใดๆ บนฟอร์ม (ใช้เพื่อความสวยงามเท่านั้น แค่ไม่ชอบให้เคอร์เซอร์มันอยู่บนปุ่ม หรือ TextBox หรือ Control)
        Me.BeginInvoke(New Action(Sub() Me.ActiveControl = Nothing))
    End Sub

#End Region

#Region "USB Watchers Events : ฟังก์ชันการดักจับการเสียบ USB ทำงานอัตโนมัติ โดยใช้ WMI Class"

    Private Sub StartUSBWatchers()
        Try
            ' USB Insert
            Dim insertQuery As New WqlEventQuery("SELECT * FROM __InstanceCreationEvent WITHIN 2 WHERE TargetInstance ISA 'Win32_USBHub'")
            insertWatcher = New ManagementEventWatcher(insertQuery)
            AddHandler insertWatcher.EventArrived, AddressOf DeviceInserted
            insertWatcher.Start()

            ' USB Remove
            Dim removeQuery As New WqlEventQuery("SELECT * FROM __InstanceDeletionEvent WITHIN 2 WHERE TargetInstance ISA 'Win32_USBHub'")
            removeWatcher = New ManagementEventWatcher(removeQuery)
            AddHandler removeWatcher.EventArrived, AddressOf DeviceRemoved
            removeWatcher.Start()

        Catch ex As Exception
            MessageBox.Show("WMI Error: " & ex.Message, "Error !", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub DeviceInserted(ByVal sender As Object, ByVal e As EventArrivedEventArgs)
        Me.Invoke(New MethodInvoker(Sub()
                                        ' MessageBox.Show("USB device inserted!", "USB Event", MessageBoxButtons.OK, MessageBoxIcon.Information)
                                        RefreshDriveComboBox()
                                    End Sub))
    End Sub

    Private Sub DeviceRemoved(ByVal sender As Object, ByVal e As EventArrivedEventArgs)
        Me.Invoke(New MethodInvoker(Sub()
                                        ' MessageBox.Show("USB device removed!", "USB Event", MessageBoxButtons.OK, MessageBoxIcon.Information)
                                        RefreshDriveComboBox()
                                    End Sub))
    End Sub

#End Region

#Region "USB Lock/UnLock : กำหนดค่าการคลิกปุ่ม Read data , Lock USB และ UnLock USB"

    Private Sub ReadSector(ByVal sender As Object, ByVal e As EventArgs, Optional ByVal sectorNumber As Integer = DEFAULT_SECTOR_NUMBER)
        Try
            If driveComboBox.SelectedItem Is Nothing Then
                MessageBox.Show("Please select a USB device!", "Warning!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                SetNonActiveControl()
                Return
            End If

            ' Extract drive letter (e.g., "E:")
            Dim selectedItem As String = driveComboBox.SelectedItem.ToString()
            Dim driveLetter As String = selectedItem.Split(" "c)(0)

            If String.IsNullOrEmpty(driveLetter) Then
                MessageBox.Show("Invalid drive selection!", "Warning!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                SetNonActiveControl()
                Return
            End If

            ' Get physical drive path
            Dim physicalPath As String = USBPhysicalDrive.GetPhysicalDrivePath(driveLetter)
            If physicalPath Is Nothing Then
                MessageBox.Show("USB device not found!", "Warning!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                SetNonActiveControl()
                Return
            End If

            ' Read sector
            Dim sectorData As String = USBRawReader.ReadSector(physicalPath, sectorNumber)
            MessageBox.Show(sectorData, "USB data", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            MessageBox.Show("Error: " & ex.Message, "Error!", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            SetNonActiveControl()
        End Try
    End Sub

    Private Sub LockUSB(ByVal sender As Object, ByVal e As EventArgs, Optional ByVal sectorNumber As Integer = DEFAULT_SECTOR_NUMBER)
        Try
            ' 1. Prepare sector data (locking signature)
            Dim sectorData(511) As Byte

            Dim inputData() As Byte = New Byte() {
                &HA2, &HA0, &HD0, &HEB, &HE5, &HB9, &H33, &H44, &H87, &HC0, &H68, &HB6, &HB7, &H26, &H99, &HC7,
                &H36, &HF7, &H38, &H89, &HB7, &HA0, &HE2, &H11, &HB0, &H5A, &H86, &HF1, &H22, &HE5, &H1, &H2F,
                &H3F, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &HFF, &H1F, &HEE, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20,
                &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20,
                &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20,
                &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20, &H20,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
                &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0
            }

            Array.Copy(inputData, sectorData, Math.Min(inputData.Length, sectorData.Length))

            ' 2. Get drive letter and physical path
            Dim selectedItem As String = driveComboBox.SelectedItem.ToString()
            Dim driveLetter As String = selectedItem.Split(" "c)(0)
            Dim physicalDrivePath As String = USBPhysicalDrive.GetPhysicalDrivePath(driveLetter)

            ' 3. Get PNPDeviceID
            Dim pnpDeviceId As String = USBPhysicalDrive.GetPnpDeviceIdFromDriveLetter(driveLetter)

            If Not String.IsNullOrEmpty(physicalDrivePath) Then
                ' 4. Write locking sector
                Dim writeSuccess As Boolean = USBRawWriter.WriteSector(physicalDrivePath, sectorNumber, sectorData)
                If Not writeSuccess Then
                    MessageBox.Show("Failed to write locking sector.", "Write Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return
                End If

                ' 5. Wait before ejecting
                Threading.Thread.Sleep(1000)

                ' 6. Eject the drive via IOCTL
                Dim physicalPath As String = USBPhysicalDrive.GetPhysicalDriveForLetter(driveLetter)
                Dim ejectSuccess As Boolean = False

                If Not String.IsNullOrEmpty(physicalPath) Then
                    ejectSuccess = USBPhysicalDrive.EjectPhysicalDrive(physicalPath)
                End If

                ' 7. Show result
                MessageBox.Show(
                    If(ejectSuccess, "Lock USB device successfully.", "Eject failed or device is in use."),
                    If(ejectSuccess, "Information", "Warning"),
                    MessageBoxButtons.OK,
                    If(ejectSuccess, MessageBoxIcon.Information, MessageBoxIcon.Warning)
                )

                ' Optional: post-eject reset
                'If Not String.IsNullOrEmpty(pnpDeviceId) Then
                '    Dim resetSuccess As Boolean = USBHelper2.FullyResetUsbDevice(pnpDeviceId)
                '    If Not resetSuccess Then
                '        MessageBox.Show("Failed to reset USB device after locking.", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning)
                '    End If
                'End If

                'USBHelper2.ForceMountVolumes()
                'USBHelper2.AssignSpecificDriveLetter("U")

                Me.SetNonActiveControl()
            Else
                MessageBox.Show("USB device not found!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Me.SetNonActiveControl()
            End If
        Catch ex As Exception
            MessageBox.Show("Error: " & ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Me.SetNonActiveControl()
        Finally
            Me.SetNonActiveControl()
        End Try
    End Sub

    Private Sub UnLockUSB(ByVal sender As Object, ByVal e As EventArgs, Optional ByVal sectorNumber As Integer = DEFAULT_SECTOR_NUMBER)
        Try
            ' 1. Prepare zero-filled sector
            Dim zeroSector(511) As Byte ' Initialized to 0x00 automatically

            ' 2. Get drive letter and physical path
            Dim selectedItem As String = driveComboBox.SelectedItem.ToString()
            Dim driveLetter As String = selectedItem.Split(" "c)(0) ' e.g., "E:"
            Dim physicalDrivePath As String = USBPhysicalDrive.GetPhysicalDrivePath(driveLetter)

            ' 3. Get PNPDeviceID (used for reset)
            Dim pnpDeviceId As String = USBPhysicalDrive.GetPnpDeviceIdFromDriveLetter(driveLetter)

            If Not String.IsNullOrEmpty(physicalDrivePath) Then
                ' 4. Write sector
                Dim writeSuccess As Boolean = USBRawWriter.WriteSector(physicalDrivePath, sectorNumber, zeroSector)
                If Not writeSuccess Then
                    MessageBox.Show("Failed to write to sector.", "Write Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return
                End If

                ' 5. Wait before continuing
                System.Threading.Thread.Sleep(1000)

                ' 6. Eject the drive via IOCTL (PhysicalDriveEjector)
                Dim physicalPath As String = USBPhysicalDrive.GetPhysicalDriveForLetter(driveLetter)
                Dim ejectSuccess As Boolean = False

                If Not String.IsNullOrEmpty(physicalPath) Then
                    ejectSuccess = USBPhysicalDrive.EjectPhysicalDrive(physicalPath)
                End If

                ' 7. Show eject result
                MessageBox.Show(
                    If(ejectSuccess, "Unlock USB device successfully.", "Eject failed or device is in use."),
                    If(ejectSuccess, "Information", "Warning"),
                    MessageBoxButtons.OK,
                    If(ejectSuccess, MessageBoxIcon.Information, MessageBoxIcon.Warning)
                )

                ' Optional reset & mount logic (commented)
                'If Not String.IsNullOrEmpty(pnpDeviceId) Then
                '    Dim resetResult As Boolean = USBHelper2.FullyResetUsbDevice(pnpDeviceId)
                '    MessageBox.Show(
                '        If(resetResult, "USB was re-enabled successfully.", "Failed to reset USB device."),
                '        "Reset Result",
                '        MessageBoxButtons.OK,
                '        If(resetResult, MessageBoxIcon.Information, MessageBoxIcon.Error)
                '    )
                'Else
                '    MessageBox.Show("Unable to find PNPDeviceID to re-enable device.", "Device Info", MessageBoxButtons.OK, MessageBoxIcon.Information)
                'End If

                'USBHelper2.ForceMountVolumes()
                'USBHelper2.AssignSpecificDriveLetter("U")

            Else
                MessageBox.Show("USB device not found!", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        Catch ex As Exception
            MessageBox.Show("Error: " & ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            Me.SetNonActiveControl()
        End Try
    End Sub

#End Region

#Region "NativeMethods, One Instant and Bring to top : ใช้เพื่อบังคับให้ฟอร์มขึ้นมาแสดงบนสุดของหน้าจอ TopMost กรณี Minimize / ถูกหน้าต่างอื่นบังอยู่ :: ทำงานในโค้ด C# / ใน VB ไม่รองรับการทำ Single Instance แบบ Manual จึงทำงานแค่สถานะ กรณี Minimize อย่างเดียวเท่านั้น"
    '' Place this at the class level (e.g., inside Form1)
    'Private Shared ReadOnly WM_SHOWME As Integer = NativeMethods.RegisterWindowMessage("USBWPRTC_SHOW_ME")

    'Protected Overrides Sub WndProc(ByRef m As Message)
    '    If m.Msg = WM_SHOWME Then
    '        If Me.WindowState = FormWindowState.Minimized Then
    '            Me.WindowState = FormWindowState.Normal
    '        End If

    '        Me.Show()
    '        Me.BringToFront()
    '        Me.Activate()
    '        Me.TopMost = True
    '        Me.TopMost = False
    '    End If

    '    MyBase.WndProc(m)
    'End Sub

    'Friend NotInheritable Class NativeMethods
    '    <DllImport("user32.dll", SetLastError:=True)>
    '    Public Shared Function RegisterWindowMessage(ByVal lpString As String) As Integer
    '    End Function

    '    <DllImport("user32.dll", SetLastError:=True)>
    '    Public Shared Function PostMessage(ByVal hWnd As IntPtr, ByVal Msg As Integer, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As Boolean
    '    End Function
    'End Class

#End Region

End Class
